
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _itemindex=R5
	.DEF _readADC=R6
	.DEF _Ain=R4
	.DEF _t_ready=R9
	.DEF _t_index=R8
	.DEF _t_char=R11
	.DEF _formatindex=R10
	.DEF _blockwidthptr=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_compare
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _uart_send
	JMP  _uart_send_complete
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_start:
	.DB  0xD,0xA,0x53,0x74,0x61,0x72,0x74,0x69
	.DB  0x6E,0x67,0x20,0x2E,0x2E,0x2E,0xD,0xA
	.DB  0x0
_done:
	.DB  0xD,0xA,0x45,0x6E,0x64,0x20,0x6F,0x66
	.DB  0x20,0x50,0x72,0x69,0x6E,0x74,0x69,0x6E
	.DB  0x67,0x20,0x64,0x61,0x74,0x61,0xD,0xA
	.DB  0x0
_minpoints:
	.DB  0xD,0xA,0x50,0x72,0x69,0x6E,0x74,0x69
	.DB  0x6E,0x67,0x20,0x4D,0x69,0x6E,0x69,0x6D
	.DB  0x75,0x6D,0x20,0x41,0x72,0x72,0x61,0x79
	.DB  0xD,0xA,0x0
_maxpoints:
	.DB  0xD,0xA,0x50,0x72,0x69,0x6E,0x74,0x69
	.DB  0x6E,0x67,0x20,0x4D,0x61,0x78,0x69,0x6D
	.DB  0x75,0x6D,0x20,0x41,0x72,0x72,0x61,0x79
	.DB  0xD,0xA,0x0
_test1:
	.DB  0xD,0xA,0x44,0x61,0x74,0x61,0xD,0xA
	.DB  0x0
_widthprint:
	.DB  0xD,0xA,0x55,0x6E,0x70,0x72,0x6F,0x63
	.DB  0x65,0x73,0x73,0x65,0x64,0x20,0x57,0x69
	.DB  0x64,0x74,0x68,0x3A,0xD,0xA,0x0
_widthbiprint:
	.DB  0xD,0xA,0x50,0x72,0x6F,0x63,0x65,0x73
	.DB  0x73,0x65,0x64,0x20,0x57,0x69,0x64,0x74
	.DB  0x68,0x20,0x69,0x6E,0x20,0x62,0x69,0x6E
	.DB  0x61,0x72,0x79,0x3A,0xD,0xA,0x0
_widthstuff:
	.DB  0x50,0x72,0x69,0x6E,0x74,0x69,0x6E,0x67
	.DB  0x20,0x57,0x69,0x64,0x74,0x68,0x73,0x74
	.DB  0x72,0x69,0x6E,0x67,0xD,0xA,0x0
_codetbl:
	.DB  0x34,0x0,0x21,0x1,0x61,0x0,0x60,0x1
	.DB  0x31,0x0,0x30,0x1,0x70,0x0,0x25,0x0
	.DB  0x24,0x1,0x64,0x0,0x9,0x1,0x49,0x0
	.DB  0x48,0x1,0x19,0x0,0x18,0x1,0x58,0x0
	.DB  0xD,0x0,0xC,0x1,0x4C,0x0,0x1C,0x0
	.DB  0x3,0x1,0x43,0x0,0x42,0x1,0x13,0x0
	.DB  0x12,0x1,0x52,0x0,0x7,0x0,0x6,0x1
	.DB  0x46,0x0,0x16,0x0,0x81,0x1,0xC1,0x0
	.DB  0xC0,0x1,0x91,0x0,0x90,0x1,0xD0,0x0
	.DB  0x85,0x0,0x84,0x1,0xC4,0x0,0x94,0x0
	.DB  0xA8,0x0,0xA2,0x0,0x8A,0x0,0x2A,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38
	.DB  0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48
	.DB  0x48,0x45,0x4C,0x4C,0x4C,0x45,0x54,0x53
	.DB  0x50,0x4C,0x41,0x59,0x54,0x4F,0x4E,0x59
	.DB  0x4E,0x41,0x54,0x45,0x54,0x31,0x30,0x30
_0x4:
	.DB  0x1,0x2,0x8,0x3,0x2,0x4,0x2D,0x23
	.DB  0x5,0xA
_0x5:
	.DB  0x43,0x52,0x41,0x43,0x4B,0x45,0x52,0x50
	.DB  0x52,0x4F,0x54,0x45,0x49,0x4E,0x52,0x41
	.DB  0x54,0x54,0x52,0x41,0x50,0x4F,0x52,0x41
	.DB  0x4E,0x47,0x45,0x53,0x43,0x52,0x45,0x41
	.DB  0x4D,0x45,0x52,0x4A,0x41,0x57,0x42,0x52
	.DB  0x4B,0x52,0x43,0x4F,0x4C,0x54,0x34,0x35
	.DB  0x4D,0x4C,0x55,0x47,0x45,0x52,0x39,0x4D
	.DB  0x4E,0x45,0x52,0x46,0x42,0x41,0x54,0x50
	.DB  0x4F,0x54,0x42,0x4F,0x4E,0x47
_0x6:
	.DB  LOW(_data+699),HIGH(_data+699)
_0x7:
	.DB  LOW(_minima+78),HIGH(_minima+78)
_0x8:
	.DB  LOW(_maxima+78),HIGH(_maxima+78)
_0xDC:
	.DB  0x14
_0x0:
	.DB  0x6E,0x75,0x6D,0x70,0x6F,0x69,0x6E,0x74
	.DB  0x73,0x3A,0x20,0x25,0x64,0xD,0xA,0x0
	.DB  0x64,0x65,0x62,0x75,0x67,0x6C,0x70,0x3A
	.DB  0x20,0x25,0x64,0xD,0xA,0x0,0x64,0x65
	.DB  0x62,0x75,0x67,0x6C,0x70,0x32,0x3A,0x20
	.DB  0x25,0x64,0xD,0xA,0x0,0x77,0x69,0x64
	.DB  0x74,0x68,0x73,0x74,0x72,0x5B,0x25,0x69
	.DB  0x5D,0x3A,0x20,0x0,0x31,0x0,0x30,0x0
	.DB  0x70,0x6D,0x69,0x6E,0x20,0x25,0x64,0xD
	.DB  0xA,0x0,0x6D,0x69,0x6E,0x6D,0x61,0x70
	.DB  0x74,0x72,0x20,0x25,0x64,0xD,0xA,0x0
	.DB  0x20,0x74,0x69,0x6D,0x65,0x3A,0x20,0x25
	.DB  0x64,0xD,0xA,0x0,0x6D,0x69,0x6E,0x72
	.DB  0x65,0x66,0x3A,0x20,0x25,0x69,0xD,0xA
	.DB  0x0,0x25,0x69,0x3A,0x20,0x0,0x43,0x44
	.DB  0x45,0x3A,0x0,0x50,0x52,0x43,0x3A,0x0
	.DB  0x4E,0x41,0x4D,0x45,0x3A,0x0,0x25,0x2D
	.DB  0x69,0x0,0x52,0x45,0x41,0x44,0x59,0x0
	.DB  0x45,0x52,0x52,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2080003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x28
	.DW  _inventory_code
	.DW  _0x3*2

	.DW  0x0A
	.DW  _inventory_price
	.DW  _0x4*2

	.DW  0x46
	.DW  _inventory_name
	.DW  _0x5*2

	.DW  0x02
	.DW  _datalast
	.DW  _0x6*2

	.DW  0x02
	.DW  _minimalastptr
	.DW  _0x7*2

	.DW  0x02
	.DW  _maximalastptr
	.DW  _0x8*2

	.DW  0x01
	.DW  0x05
	.DW  _0xDC*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x02
	.DW  __base_y_G104
	.DW  _0x2080003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;// headers
;#include <Mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <stdlib.h>
;#include <delay.h>
;#include <string.h>
;#include <math.h>
;#include <lcd.h>
;
;
;#define begin {
;#define end }
;
;// dependent on scan velocity and ADC rate
;#define longwidth 10
;#define shortwidth 3
;
;#define delta 50  // assumed difference in a transition, may change to dynamic later
;
;//***************************//
;//   Final Decode Defines
;
;#define stringlength 7 //for convinience, we'll assume we only ever scanner
;                       //barcode string of length 7, with first and last
;                       //characters being *, 2nd to last character will
;                       //be the error checking
;#define inven 10       //size of our inventory, assume 10 at the moment
;
;//lcd definition and setup
;#define LCDwidth 16
;
;//LCD uses PORTC
;#asm
    .equ __lcd_port=0x15
; 0000 0023 #endasm
;
;//**************************//
;
;
;typedef unsigned char uchar;
;
;flash char start[] = "\r\nStarting ...\r\n";
;flash char done[] = "\r\nEnd of Printing data\r\n";
;flash char minpoints[] = "\r\nPrinting Minimum Array\r\n";
;flash char maxpoints[] = "\r\nPrinting Maximum Array\r\n";
;flash char test1[] = "\r\nData\r\n";
;flash char widthprint[] = "\r\nUnprocessed Width:\r\n";
;flash char widthbiprint[] = "\r\nProcessed Width in binary:\r\n";
;flash char widthstuff[] = "Printing Widthstring\r\n";
;
;//***************************//
;// codetbl, inventory code, price, and name
;#include "codeandinv.h"

	.DSEG
;//***************************//
;
;
;//flash char newline[] = "\r";
;
;int readADC;
;uchar Ain;
;uchar t_buffer[20]; // output string
;uchar t_ready;
;uchar t_index;
;uchar t_char;
;uchar formatindex;
;unsigned char data[700]; // maximally sized, can be increased by decreasing data stack size, stores read ADCH vals
;uchar blockwidth[100]; // store the length of each bar
;uchar *blockwidthptr;
;uchar currentwidth; // width of current block so far
;unsigned char *datalast = data + 699;
;unsigned char *dataptr;
;uchar takedata; // tells the timer0 interrupt to put ADCH data in data
;uchar newdata;
;
;// vars for peakdet algorithm
;int mn; // current minimum value
;uchar mnpos; // point number of minimum value
;int mx; // current maximum
;uchar mxpos; // point number of maximum value
;uchar lookformax; // are we looking for the next max or the next min transition
;unsigned int minima[40]; // store indices of the transitions to minima (minima start points)
;unsigned int mintime[40];
;unsigned int *mintimeptr;
;unsigned int *minimalastptr = minima + 39;
;unsigned int *minimaptr;
;unsigned int maxima[40]; // store indices of the transitions to maxima (maxima start points)
;unsigned int maxtime[40];
;unsigned int *maxtimeptr;
;unsigned int *maximalastptr = maxima + 39;
;unsigned int *maximaptr;
;int currentval; // last read val from ADC
;unsigned int pointnum; // count number of points read on this scan
;unsigned int lastpoint;
;uchar debugloopcounter;
;uchar debugloopcounter2;
;
;// Variables for transition detection
;uchar longaverage;  // keeps average of previous 10 values or so
;uchar shortaverage; // keep average of previous 3 (to catch the transition)
;// are we looking for a 0-1 or 1-0 transition
;// 0 = 0 to 1
;// 1 = 1 to 0
;uchar lookfor;
;
;
;//width code string
;unsigned int width[69], widthbinary[69];
;
;void spitData(void);
;void spitIndices(void);
;void fmtEndline(unsigned char*); // adds \n\r\0 to end of t_buffer
;void getwidthbinary(void); //fills in width and widthbinary array
;void spitwidth(void); //spits out width and widthbinary on hyper trm
;
;/* finaldecode function listing */
;
;//extract the 69 character array, widthbinary, into 7 separate integers for comparison
;//widthstring[7] are rdy for comparison after this
;void widthseparate(void);
;
;//convert a scanned width code character into an ascii, takes
;//an unsigned int that contains the character in width code format
;unsigned char width2ascii(unsigned int widthchar);
;
;//convert a scanned character width code into an error value,
;//according to barcode standard, Code 39
;unsigned char width2error(unsigned int widthchar);
;
;//extract the actual code from the overall code
;void getcode(void);
;
;//returns 1 if the scanned barcode strings passes the code 39 error checking
;//prodedure, returns 0 otherwise
;unsigned char errorcheck (unsigned char* errorarray);
;
;
;// LCD functions //
;
;//initialize the LCD, called once in the beginning before while loop
;void preplcd(void);
;
;//clean up the LCD screen, other than the labels, no need to call directly
;void wipelcd(void);
;
;//print out scanned product's code, name and price
;void printproduct(unsigned char invenindex);
;
;// print ascii values in itemcode
;void printascii(unsigned char *ascii);
;
;// print ready on lcd
;void printready(void);
;
;//print out error on to the LCD screen, use when appropriate
;void printerror(void);
;
;
;//**********************************************************
;//timer 0 compare ISR // executes every 1 ms
;interrupt [TIM0_COMP] void timer0_compare(void)
; 0000 00A1 begin

	.CSEG
_timer0_compare:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00A2   *dataptr = ADCH;
	IN   R30,0x5
	LDS  R26,_dataptr
	LDS  R27,_dataptr+1
	ST   X,R30
; 0000 00A3   currentval = *dataptr;  // currentval: int  dataptr: uchar
	LDI  R31,0
	STS  _currentval,R30
	STS  _currentval+1,R31
; 0000 00A4 
; 0000 00A5   if (takedata & (dataptr < datalast) )
	LDS  R30,_datalast
	LDS  R31,_datalast+1
	CALL __LTW12U
	LDS  R26,_takedata
	AND  R30,R26
	BREQ _0x9
; 0000 00A6   begin
; 0000 00A7     //*dataptr = ADCH;
; 0000 00A8     dataptr++;
	LDI  R26,LOW(_dataptr)
	LDI  R27,HIGH(_dataptr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 00A9   end
; 0000 00AA 
; 0000 00AB   if (takedata & (maximaptr < maximalastptr) & (minimaptr < minimalastptr) )  // don't overrun memory
_0x9:
	LDS  R30,_maximalastptr
	LDS  R31,_maximalastptr+1
	LDS  R26,_maximaptr
	LDS  R27,_maximaptr+1
	CALL __LTW12U
	LDS  R26,_takedata
	AND  R30,R26
	MOV  R0,R30
	LDS  R30,_minimalastptr
	LDS  R31,_minimalastptr+1
	LDS  R26,_minimaptr
	LDS  R27,_minimaptr+1
	CALL __LTW12U
	AND  R30,R0
	BRNE PC+3
	JMP _0xA
; 0000 00AC   begin
; 0000 00AD     //putsf(test1);
; 0000 00AE     pointnum++;  // we are adding a new point
	LDI  R26,LOW(_pointnum)
	LDI  R27,HIGH(_pointnum)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 00AF     // currentval already updated above
; 0000 00B0     if (currentval > mx)
	LDS  R30,_mx
	LDS  R31,_mx+1
	LDS  R26,_currentval
	LDS  R27,_currentval+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xB
; 0000 00B1     begin
; 0000 00B2       mx = currentval;
	LDS  R30,_currentval
	LDS  R31,_currentval+1
	STS  _mx,R30
	STS  _mx+1,R31
; 0000 00B3       //mxpos = pointnum;
; 0000 00B4     end
; 0000 00B5     if (currentval < mn)
_0xB:
	LDS  R30,_mn
	LDS  R31,_mn+1
	LDS  R26,_currentval
	LDS  R27,_currentval+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0xC
; 0000 00B6     begin
; 0000 00B7       mn = currentval;
	LDS  R30,_currentval
	LDS  R31,_currentval+1
	STS  _mn,R30
	STS  _mn+1,R31
; 0000 00B8       //mnpos = pointnum;
; 0000 00B9     end
; 0000 00BA     if (lookformax) // if looking for 0-1 transition
_0xC:
	LDS  R30,_lookformax
	CPI  R30,0
	BRNE PC+3
	JMP _0xD
; 0000 00BB     begin
; 0000 00BC       if (currentval < mx - delta)
	LDS  R30,_mx
	LDS  R31,_mx+1
	SBIW R30,50
	LDS  R26,_currentval
	LDS  R27,_currentval+1
	CP   R26,R30
	CPC  R27,R31
	BRLT PC+3
	JMP _0xE
; 0000 00BD       begin
; 0000 00BE         *minimaptr = (pointnum - lastpoint);
	LDS  R26,_lastpoint
	LDS  R27,_lastpoint+1
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	SUB  R30,R26
	SBC  R31,R27
	LDS  R26,_minimaptr
	LDS  R27,_minimaptr+1
	ST   X+,R30
	ST   X,R31
; 0000 00BF         *mintimeptr = pointnum;
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	LDS  R26,_mintimeptr
	LDS  R27,_mintimeptr+1
	ST   X+,R30
	ST   X,R31
; 0000 00C0         mintimeptr++;
	LDI  R26,LOW(_mintimeptr)
	LDI  R27,HIGH(_mintimeptr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,2
	ST   -X,R31
	ST   -X,R30
; 0000 00C1         lastpoint = pointnum;
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	STS  _lastpoint,R30
	STS  _lastpoint+1,R31
; 0000 00C2         minimaptr++;
	LDI  R26,LOW(_minimaptr)
	LDI  R27,HIGH(_minimaptr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,2
	ST   -X,R31
	ST   -X,R30
; 0000 00C3         mn = currentval;
	LDS  R30,_currentval
	LDS  R31,_currentval+1
	STS  _mn,R30
	STS  _mn+1,R31
; 0000 00C4         lookformax = 0;
	LDI  R30,LOW(0)
	STS  _lookformax,R30
; 0000 00C5         debugloopcounter++;
	LDS  R30,_debugloopcounter
	SUBI R30,-LOW(1)
	STS  _debugloopcounter,R30
; 0000 00C6       end
; 0000 00C7     end
_0xE:
; 0000 00C8     else //(!lookformax)
	RJMP _0xF
_0xD:
; 0000 00C9     begin
; 0000 00CA       if (currentval > mn + delta)
	LDS  R30,_mn
	LDS  R31,_mn+1
	ADIW R30,50
	LDS  R26,_currentval
	LDS  R27,_currentval+1
	CP   R30,R26
	CPC  R31,R27
	BRLT PC+3
	JMP _0x10
; 0000 00CB       begin
; 0000 00CC         *maximaptr = (pointnum - lastpoint);
	LDS  R26,_lastpoint
	LDS  R27,_lastpoint+1
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	SUB  R30,R26
	SBC  R31,R27
	LDS  R26,_maximaptr
	LDS  R27,_maximaptr+1
	ST   X+,R30
	ST   X,R31
; 0000 00CD         *maxtimeptr = pointnum;
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	LDS  R26,_maxtimeptr
	LDS  R27,_maxtimeptr+1
	ST   X+,R30
	ST   X,R31
; 0000 00CE         maxtimeptr++;
	LDI  R26,LOW(_maxtimeptr)
	LDI  R27,HIGH(_maxtimeptr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,2
	ST   -X,R31
	ST   -X,R30
; 0000 00CF         lastpoint = pointnum;
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	STS  _lastpoint,R30
	STS  _lastpoint+1,R31
; 0000 00D0         maximaptr++;
	LDI  R26,LOW(_maximaptr)
	LDI  R27,HIGH(_maximaptr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,2
	ST   -X,R31
	ST   -X,R30
; 0000 00D1         mx = currentval;
	LDS  R30,_currentval
	LDS  R31,_currentval+1
	STS  _mx,R30
	STS  _mx+1,R31
; 0000 00D2         lookformax = 1;
	LDI  R30,LOW(1)
	STS  _lookformax,R30
; 0000 00D3         debugloopcounter2++;
	LDS  R30,_debugloopcounter2
	SUBI R30,-LOW(1)
	STS  _debugloopcounter2,R30
; 0000 00D4       end
; 0000 00D5     end // end if !lookformax
_0x10:
_0xF:
; 0000 00D6   end // end if takedata
; 0000 00D7 end
_0xA:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;
;// Uart transmit complete interrupt, could be used to
;// start spitting out next ADC conversion
;interrupt [USART_TXC] void uart_send_complete(void)
; 0000 00DC begin
_uart_send_complete:
; 0000 00DD 
; 0000 00DE end
	RETI
;
;/**********************************************************/
;//UART xmit-empty ISR
;interrupt [USART_DRE] void uart_send(void)
; 0000 00E3 begin
_uart_send:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00E4 	t_char = t_buffer[++t_index];
	INC  R8
	MOV  R30,R8
	LDI  R31,0
	SUBI R30,LOW(-_t_buffer)
	SBCI R31,HIGH(-_t_buffer)
	LD   R11,Z
; 0000 00E5 	if (t_char == 0)
	TST  R11
	BRNE _0x11
; 0000 00E6 	begin
; 0000 00E7 		UCSRB.5=0; //kill isr
	CBI  0xA,5
; 0000 00E8 		t_ready=1; //transmit done
	LDI  R30,LOW(1)
	MOV  R9,R30
; 0000 00E9 	end
; 0000 00EA 
; 0000 00EB 	else	UDR = t_char ;     //send the char
	RJMP _0x14
_0x11:
	OUT  0xC,R11
; 0000 00EC end
_0x14:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;/**********************************************************/
;
;//**********************************************************
;//  -- nonblocking print: initializes ISR-driven
;// transmit. This routine merely sets up the ISR, then
;//send one character, The ISR does all the work.
;void puts_int(void)
; 0000 00F5 begin
_puts_int:
; 0000 00F6   t_ready=0;
	CLR  R9
; 0000 00F7   t_index=0;
	CLR  R8
; 0000 00F8   if (t_buffer[0]>0)
	LDS  R26,_t_buffer
	CPI  R26,LOW(0x1)
	BRLO _0x15
; 0000 00F9   begin
; 0000 00FA   	putchar(t_buffer[0]);
	CALL _putchar
; 0000 00FB   	UCSRB.5=1;  // turn on UDR empty interrupt
	SBI  0xA,5
; 0000 00FC   end
; 0000 00FD end
_0x15:
	RET
;
;void main(void)
; 0000 0100 begin
_main:
; 0000 0101   unsigned char loopi,inveni, characteri;
; 0000 0102   unsigned char codematch=0;
; 0000 0103   char full = 0;
; 0000 0104   dataptr = data;
;	loopi -> R17
;	inveni -> R16
;	characteri -> R19
;	codematch -> R18
;	full -> R21
	LDI  R18,0
	LDI  R21,0
	LDI  R30,LOW(_data)
	LDI  R31,HIGH(_data)
	STS  _dataptr,R30
	STS  _dataptr+1,R31
; 0000 0105   takedata = 0; // variable to tell timer0 interrupt when to write new data
	LDI  R30,LOW(0)
	STS  _takedata,R30
; 0000 0106 
; 0000 0107   DDRD = 0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
; 0000 0108   PORTD.7 = 0; // turn protoboard led on
	CBI  0x12,7
; 0000 0109 
; 0000 010A   UCSRB = 0x08; // Enable Tx only
	LDI  R30,LOW(8)
	OUT  0xA,R30
; 0000 010B   UBRRL = 103;  // 9600 Baud
	LDI  R30,LOW(103)
	OUT  0x9,R30
; 0000 010C 
; 0000 010D   TIMSK = 2;		    //turn on timer 0 cmp match ISR
	LDI  R30,LOW(2)
	OUT  0x39,R30
; 0000 010E   //OCR0 = 249;  	        //set the compare register to 250 time ticks - 1ms
; 0000 010F   OCR0 = 125;
	LDI  R30,LOW(125)
	OUT  0x3C,R30
; 0000 0110   TCCR0 = 0b00001011;	//prescalar to 64 and turn on clear-on-match
	LDI  R30,LOW(11)
	OUT  0x33,R30
; 0000 0111 
; 0000 0112   ADMUX = 0b01100000;  // AVCC (with capacitor), Left Adjust result, ADC0
	LDI  R30,LOW(96)
	OUT  0x7,R30
; 0000 0113   //enable ADC and set prescaler to 1/128*16MHz=125,000
; 0000 0114   //and clear interupt enable
; 0000 0115   //and start a conversion
; 0000 0116   ADCSR = 0b11000111;
	LDI  R30,LOW(199)
	OUT  0x6,R30
; 0000 0117   SFIOR = 0b00000000; // set to free running mode
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0118 
; 0000 0119   #asm
; 0000 011A   	sei
  	sei
; 0000 011B   #endasm
; 0000 011C 
; 0000 011D   formatindex = 0;//edit 420
	CLR  R10
; 0000 011E 
; 0000 011F   putsf(start); // print startup string
	LDI  R26,LOW(_start*2)
	LDI  R27,HIGH(_start*2)
	CALL _putsf
; 0000 0120 
; 0000 0121   delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0122 
; 0000 0123   while (ADCSR.6) {} // wait for first conversion to finish
_0x1A:
	SBIC 0x6,6
	RJMP _0x1A
; 0000 0124   readADC = ADCH;
	IN   R6,5
	CLR  R7
; 0000 0125   ADCSR.5 = 1; // auto trigger the ADC
	SBI  0x6,5
; 0000 0126   ADCSR.6 = 1; // start a new conversion so that it free runs
	SBI  0x6,6
; 0000 0127 
; 0000 0128   itoa(readADC, t_buffer); // convert ADCH to a string
	ST   -Y,R7
	ST   -Y,R6
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	CALL _itoa
; 0000 0129   fmtEndline(t_buffer);
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	RCALL _fmtEndline
; 0000 012A   formatindex = 0;
	CLR  R10
; 0000 012B 
; 0000 012C   puts_int(); // print first ADC value
	RCALL _puts_int
; 0000 012D 
; 0000 012E   //while(1) {}
; 0000 012F   DDRB = 0x00; // PORTB input
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 0130   PORTB = 0xFF;   // pull-up
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 0131 
; 0000 0132   dataptr = data;
	LDI  R30,LOW(_data)
	LDI  R31,HIGH(_data)
	STS  _dataptr,R30
	STS  _dataptr+1,R31
; 0000 0133   blockwidthptr = blockwidth;
	LDI  R30,LOW(_blockwidth)
	LDI  R31,HIGH(_blockwidth)
	MOVW R12,R30
; 0000 0134   currentwidth = 0;
	LDI  R30,LOW(0)
	STS  _currentwidth,R30
; 0000 0135   lookfor = 1; // looking for 1-0 transition (white -> black)
	LDI  R30,LOW(1)
	STS  _lookfor,R30
; 0000 0136   longaverage = 0;
	LDI  R30,LOW(0)
	STS  _longaverage,R30
; 0000 0137   shortaverage = 0;
	STS  _shortaverage,R30
; 0000 0138   full = 0;
	LDI  R21,LOW(0)
; 0000 0139 
; 0000 013A   preplcd();
	RCALL _preplcd
; 0000 013B   wipelcd();
	RCALL _wipelcd
; 0000 013C   printerror();
	RCALL _printerror
; 0000 013D   wipelcd();
	RCALL _wipelcd
; 0000 013E   printproduct(9);
	LDI  R26,LOW(9)
	RCALL _printproduct
; 0000 013F   delay_ms(3000);
	LDI  R26,LOW(3000)
	LDI  R27,HIGH(3000)
	CALL _delay_ms
; 0000 0140   printready();
	RCALL _printready
; 0000 0141 
; 0000 0142   while(1)
_0x21:
; 0000 0143   begin
; 0000 0144     char tempi, tempi2;
; 0000 0145     unsigned int tempint;
; 0000 0146     unsigned char tempstring;
; 0000 0147     if (PINB.0 == 0)
	SBIW R28,5
;	tempi -> Y+4
;	tempi2 -> Y+3
;	tempint -> Y+1
;	tempstring -> Y+0
	SBIC 0x16,0
	RJMP _0x24
; 0000 0148     begin
; 0000 0149       if (!takedata)
	LDS  R30,_takedata
	CPI  R30,0
	BRNE _0x25
; 0000 014A       begin
; 0000 014B       for (tempi = 0; tempi < 40; tempi ++)
	LDI  R30,LOW(0)
	STD  Y+4,R30
_0x27:
	LDD  R26,Y+4
	CPI  R26,LOW(0x28)
	BRSH _0x28
; 0000 014C       begin
; 0000 014D         minima[tempi] = 0;
	LDD  R30,Y+4
	LDI  R26,LOW(_minima)
	LDI  R27,HIGH(_minima)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0000 014E         maxima[tempi] = 0;
	LDD  R30,Y+4
	LDI  R26,LOW(_maxima)
	LDI  R27,HIGH(_maxima)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0000 014F       end
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
	RJMP _0x27
_0x28:
; 0000 0150       end
; 0000 0151 //       mn = 1000;
; 0000 0152 //       mx = -1000;
; 0000 0153 //       lookformax = 1; //edit 426, ignore the first minimum, the rest is good
; 0000 0154 //       pointnum = 0;
; 0000 0155 //       lastpoint = 0; // remember the previous index of transition
; 0000 0156 //       maximaptr = maxima;
; 0000 0157 //       minimaptr = minima;
; 0000 0158 //       maxtimeptr = maxtime;
; 0000 0159 //       mintimeptr = mintime;
; 0000 015A //       mxpos = 0;
; 0000 015B //       mnpos = 0;
; 0000 015C //       debugloopcounter = 0;
; 0000 015D //       debugloopcounter2 = 0;
; 0000 015E //       dataptr = data;
; 0000 015F 
; 0000 0160       takedata = 1; // interrupt should call interpret function also
_0x25:
	LDI  R30,LOW(1)
	STS  _takedata,R30
; 0000 0161       newdata = 1;
	STS  _newdata,R30
; 0000 0162     end
; 0000 0163     else {takedata = 0;}
	RJMP _0x29
_0x24:
	LDI  R30,LOW(0)
	STS  _takedata,R30
_0x29:
; 0000 0164     if (PINB.2 == 0) // initialize routine, and spit the last taken data
	SBIC 0x16,2
	RJMP _0x2A
; 0000 0165     begin
; 0000 0166       widthstring[0] = 0xFFFF;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STS  _widthstring,R30
	STS  _widthstring+1,R31
; 0000 0167 
; 0000 0168       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0169 
; 0000 016A       //spitData();
; 0000 016B       //spitIndices();
; 0000 016C       // the below is useful info from spitindices
; 0000 016D       sprintf(t_buffer, "numpoints: %d\r\n", pointnum);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_pointnum
	LDS  R31,_pointnum+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 016E       puts_int();
	RCALL _puts_int
; 0000 016F       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0170       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0171       sprintf(t_buffer, "debuglp: %d\r\n", debugloopcounter);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_debugloopcounter
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0172       puts_int();
	RCALL _puts_int
; 0000 0173       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0174       sprintf(t_buffer, "debuglp2: %d\r\n", debugloopcounter2);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,30
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_debugloopcounter2
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0175       puts_int();
	RCALL _puts_int
; 0000 0176       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0177       getwidthbinary();
	RCALL _getwidthbinary
; 0000 0178       //spitwidth();
; 0000 0179       //putsf(done);
; 0000 017A 
; 0000 017B 
; 0000 017C 
; 0000 017D       ////
; 0000 017E       wipelcd();  // clean up lcd for this barcode
	RCALL _wipelcd
; 0000 017F 
; 0000 0180       // Decode and print barcode //
; 0000 0181 
; 0000 0182       // guarantee widthbinary is natex
; 0000 0183       //widthbinary[0] = 0; widthbinary[1] = 1; widthbinary[2] = 0; widthbinary[3] = 0; widthbinary[4] = 1; widthbinary[5] = 0; widthbinary[6] = 1; widthbinary[7] = 0; widthbinary[8] = 0; widthbinary[9] = 0; widthbinary[10] = 0; widthbinary[11] = 0; widthbinary[12] = 0; widthbinary[13] = 0; widthbinary[14] = 1; widthbinary[15] = 0; widthbinary[16] = 0; widthbinary[17] = 1; widthbinary[18] = 1; widthbinary[19] = 0; widthbinary[20] = 1; widthbinary[21] = 0; widthbinary[22] = 0; widthbinary[23] = 0; widthbinary[24] = 0; widthbinary[25] = 1; widthbinary[26] = 0; widthbinary[27] = 0; widthbinary[28] = 1; widthbinary[29] = 0; widthbinary[30] = 0; widthbinary[31] = 0; widthbinary[32] = 0; widthbinary[33] = 0; widthbinary[34] = 1; widthbinary[35] = 0; widthbinary[36] = 1; widthbinary[37] = 1; widthbinary[38] = 0; widthbinary[39] = 0; widthbinary[40] = 1; widthbinary[41] = 0; widthbinary[42] = 0; widthbinary[43] = 0; widthbinary[44] = 1; widthbinary[45] = 1; widthbinary[46] = 0; widthbinary[47] = 0; widthbinary[48] = 0; widthbinary[49] = 0; widthbinary[50] = 0; widthbinary[51] = 1; widthbinary[52] = 0; widthbinary[53] = 0; widthbinary[54] = 1; widthbinary[55] = 0; widthbinary[56] = 0; widthbinary[57] = 0; widthbinary[58] = 1; widthbinary[59] = 0; widthbinary[60] = 0; widthbinary[61] = 1; widthbinary[62] = 0; widthbinary[63] = 0; widthbinary[64] = 1; widthbinary[65] = 0; widthbinary[66] = 1; widthbinary[67] = 0; widthbinary[68] = 0;
; 0000 0184 
; 0000 0185       spitwidth();
	RCALL _spitwidth
; 0000 0186       putsf(done);
	LDI  R26,LOW(_done*2)
	LDI  R27,HIGH(_done*2)
	CALL _putsf
; 0000 0187 
; 0000 0188       widthseparate(); // takes widthbinary and converts to widthstring[7]
	RCALL _widthseparate
; 0000 0189 
; 0000 018A 
; 0000 018B       putsf(widthstuff);
	LDI  R26,LOW(_widthstuff*2)
	LDI  R27,HIGH(_widthstuff*2)
	CALL _putsf
; 0000 018C       for (tempi2 = 0; tempi2 < 7; tempi2++)
	LDI  R30,LOW(0)
	STD  Y+3,R30
_0x2C:
	LDD  R26,Y+3
	CPI  R26,LOW(0x7)
	BRLO PC+3
	JMP _0x2D
; 0000 018D       begin
; 0000 018E 
; 0000 018F         tempint = widthstring[tempi2];
	LDD  R30,Y+3
	LDI  R26,LOW(_widthstring)
	LDI  R27,HIGH(_widthstring)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+1,R30
	STD  Y+1+1,R31
; 0000 0190         sprintf(t_buffer, "widthstr[%i]: ", tempi2);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,45
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0191         puts(t_buffer);
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	CALL _puts
; 0000 0192 
; 0000 0193         for (tempi = 0; tempi < 16; tempi++)
	LDI  R30,LOW(0)
	STD  Y+4,R30
_0x2F:
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x30
; 0000 0194         begin
; 0000 0195           if (tempint & 0x8000)
	LDD  R30,Y+2
	ANDI R30,LOW(0x80)
	BREQ _0x31
; 0000 0196           begin
; 0000 0197             sprintf(t_buffer, "1");
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,60
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0198           end
; 0000 0199           else
	RJMP _0x32
_0x31:
; 0000 019A           begin
; 0000 019B             sprintf(t_buffer, "0", tempint & 0x80);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,62
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ANDI R30,LOW(0x80)
	ANDI R31,HIGH(0x80)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 019C           end
_0x32:
; 0000 019D           puts_int();
	RCALL _puts_int
; 0000 019E           while (!t_ready) {};
_0x33:
	TST  R9
	BREQ _0x33
; 0000 019F           tempint = tempint << 1;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LSL  R30
	ROL  R31
	STD  Y+1,R30
	STD  Y+1+1,R31
; 0000 01A0         end
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
	RJMP _0x2F
_0x30:
; 0000 01A1         sprintf(t_buffer, "\r\n");
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,13
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01A2         puts_int();
	RCALL _puts_int
; 0000 01A3         while (!t_ready) {};
_0x36:
	TST  R9
	BREQ _0x36
; 0000 01A4       end
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	RJMP _0x2C
_0x2D:
; 0000 01A5 
; 0000 01A6       /*debug
; 0000 01A7       widthstring[0] = 0b0000000010010100; //*
; 0000 01A8       widthstring[1] = 0b0000000000010011; //N
; 0000 01A9       widthstring[2] = 0b0000000100001001; //A
; 0000 01AA       widthstring[3] = 0b0000000000010110; //T
; 0000 01AB       widthstring[4] = 0b0000000100011000; //E
; 0000 01AC       widthstring[5] = 0b0000000010010001; //X
; 0000 01AD       widthstring[6] = 0b0000000010010100; //*
; 0000 01AE       */
; 0000 01AF       putsf(widthstuff);
	LDI  R26,LOW(_widthstuff*2)
	LDI  R27,HIGH(_widthstuff*2)
	CALL _putsf
; 0000 01B0       for (tempi2 = 0; tempi2 < 7; tempi2++)
	LDI  R30,LOW(0)
	STD  Y+3,R30
_0x3A:
	LDD  R26,Y+3
	CPI  R26,LOW(0x7)
	BRLO PC+3
	JMP _0x3B
; 0000 01B1       begin
; 0000 01B2 
; 0000 01B3         tempint = widthstring[tempi2];
	LDD  R30,Y+3
	LDI  R26,LOW(_widthstring)
	LDI  R27,HIGH(_widthstring)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+1,R30
	STD  Y+1+1,R31
; 0000 01B4         sprintf(t_buffer, "widthstr[%i]: ", tempi2);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,45
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 01B5         puts(t_buffer);
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	CALL _puts
; 0000 01B6 
; 0000 01B7         for (tempi = 0; tempi < 16; tempi++)
	LDI  R30,LOW(0)
	STD  Y+4,R30
_0x3D:
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x3E
; 0000 01B8         begin
; 0000 01B9           if (tempint & 0x8000)
	LDD  R30,Y+2
	ANDI R30,LOW(0x80)
	BREQ _0x3F
; 0000 01BA           begin
; 0000 01BB             sprintf(t_buffer, "1");
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,60
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01BC           end
; 0000 01BD           else
	RJMP _0x40
_0x3F:
; 0000 01BE           begin
; 0000 01BF             sprintf(t_buffer, "0", tempint & 0x80);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,62
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ANDI R30,LOW(0x80)
	ANDI R31,HIGH(0x80)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 01C0           end
_0x40:
; 0000 01C1           puts_int();
	RCALL _puts_int
; 0000 01C2           while (!t_ready) {};
_0x41:
	TST  R9
	BREQ _0x41
; 0000 01C3           tempint = tempint << 1;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LSL  R30
	ROL  R31
	STD  Y+1,R30
	STD  Y+1+1,R31
; 0000 01C4         end
	LDD  R30,Y+4
	SUBI R30,-LOW(1)
	STD  Y+4,R30
	RJMP _0x3D
_0x3E:
; 0000 01C5         sprintf(t_buffer, "\r\n");
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,13
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01C6         puts_int();
	RCALL _puts_int
; 0000 01C7         while (!t_ready) {};
_0x44:
	TST  R9
	BREQ _0x44
; 0000 01C8       end
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	RJMP _0x3A
_0x3B:
; 0000 01C9 
; 0000 01CA       for (loopi = 0; loopi < 7; loopi++)
	LDI  R17,LOW(0)
_0x48:
	CPI  R17,7
	BRSH _0x49
; 0000 01CB       begin
; 0000 01CC         totalcode[loopi] = width2ascii(widthstring[loopi]); // totalcode contains ascii conversions
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_totalcode)
	SBCI R31,HIGH(-_totalcode)
	PUSH R31
	PUSH R30
	MOV  R30,R17
	LDI  R26,LOW(_widthstring)
	LDI  R27,HIGH(_widthstring)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	RCALL _width2ascii
	POP  R26
	POP  R27
	ST   X,R30
; 0000 01CD         errorvalue[loopi] = width2error(widthstring[loopi]);
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_errorvalue)
	SBCI R31,HIGH(-_errorvalue)
	PUSH R31
	PUSH R30
	MOV  R30,R17
	LDI  R26,LOW(_widthstring)
	LDI  R27,HIGH(_widthstring)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	RCALL _width2error
	POP  R26
	POP  R27
	ST   X,R30
; 0000 01CE       end
	SUBI R17,-1
	RJMP _0x48
_0x49:
; 0000 01CF       // only continue if we have no errors, otherwise, display error
; 0000 01D0       if (! errorcheck(errorvalue) ) // if there is an error
	LDI  R26,LOW(_errorvalue)
	LDI  R27,HIGH(_errorvalue)
	RCALL _errorcheck
	CPI  R30,0
	BRNE _0x4A
; 0000 01D1       begin
; 0000 01D2         printerror();
	RCALL _printerror
; 0000 01D3         delay_ms(3000);
	LDI  R26,LOW(3000)
	LDI  R27,HIGH(3000)
	RJMP _0xDA
; 0000 01D4         printready();
; 0000 01D5       end
; 0000 01D6       else // no error
_0x4A:
; 0000 01D7       begin
; 0000 01D8         //printproduct(3);
; 0000 01D9         //delay_ms(3000);
; 0000 01DA 
; 0000 01DB         itemindex = 0xFF; // invalid so far
	LDI  R30,LOW(255)
	MOV  R5,R30
; 0000 01DC         getcode(); // store the 4 chars in itemcode
	RCALL _getcode
; 0000 01DD         // find invindex
; 0000 01DE 
; 0000 01DF         /*debug
; 0000 01E0         itemcode[0] = 'N';
; 0000 01E1         itemcode[1] = 'A';
; 0000 01E2         itemcode[2] = 'T';
; 0000 01E3         itemcode[3] = 'E';
; 0000 01E4          */
; 0000 01E5         for(inveni=0; inveni<inven;  inveni++)
	LDI  R16,LOW(0)
_0x4D:
	CPI  R16,10
	BRSH _0x4E
; 0000 01E6         begin
; 0000 01E7           for(characteri=0; characteri<stringlength-3; characteri++)
	LDI  R19,LOW(0)
_0x50:
	CPI  R19,4
	BRSH _0x51
; 0000 01E8           begin
; 0000 01E9             if(itemcode[characteri]==inventory_code[inveni][characteri]) codematch++;
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_itemcode)
	SBCI R31,HIGH(-_itemcode)
	LD   R0,Z
	MOV  R30,R16
	LDI  R26,LOW(_inventory_code)
	LDI  R27,HIGH(_inventory_code)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	LD   R30,X
	CP   R30,R0
	BRNE _0x52
	SUBI R18,-1
; 0000 01EA           end
_0x52:
	SUBI R19,-1
	RJMP _0x50
_0x51:
; 0000 01EB           if (codematch==4) //found a match
	CPI  R18,4
	BRNE _0x53
; 0000 01EC           begin
; 0000 01ED             itemindex = inveni;
	MOV  R5,R16
; 0000 01EE           end
; 0000 01EF           codematch=0;
_0x53:
	LDI  R18,LOW(0)
; 0000 01F0           if (itemindex != 0xFF) break; // if we found a match, stop
	LDI  R30,LOW(255)
	CP   R30,R5
	BRNE _0x4E
; 0000 01F1         end
	SUBI R16,-1
	RJMP _0x4D
_0x4E:
; 0000 01F2         //itemindex = 7;
; 0000 01F3         if(itemindex<10) printproduct(itemindex);
	LDI  R30,LOW(10)
	CP   R5,R30
	BRSH _0x55
	MOV  R26,R5
	RCALL _printproduct
; 0000 01F4         else  // the valid code found was ok
	RJMP _0x56
_0x55:
; 0000 01F5         begin
; 0000 01F6           printerror();
	RCALL _printerror
; 0000 01F7         end
_0x56:
; 0000 01F8 
; 0000 01F9         delay_ms(5000);
	LDI  R26,LOW(5000)
	LDI  R27,HIGH(5000)
_0xDA:
	CALL _delay_ms
; 0000 01FA         printready();
	RCALL _printready
; 0000 01FB 
; 0000 01FC 
; 0000 01FD       end // end else no error found in ascii
; 0000 01FE 
; 0000 01FF 
; 0000 0200 
; 0000 0201       mn = 1000;
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	STS  _mn,R30
	STS  _mn+1,R31
; 0000 0202       mx = -1000;
	LDI  R30,LOW(64536)
	LDI  R31,HIGH(64536)
	STS  _mx,R30
	STS  _mx+1,R31
; 0000 0203       lookformax = 1; //edit 426, ignore the first minimum, the rest is good
	LDI  R30,LOW(1)
	STS  _lookformax,R30
; 0000 0204       pointnum = 0;
	LDI  R30,LOW(0)
	STS  _pointnum,R30
	STS  _pointnum+1,R30
; 0000 0205       lastpoint = 0; // remember the previous index of transition
	STS  _lastpoint,R30
	STS  _lastpoint+1,R30
; 0000 0206       maximaptr = maxima;
	LDI  R30,LOW(_maxima)
	LDI  R31,HIGH(_maxima)
	STS  _maximaptr,R30
	STS  _maximaptr+1,R31
; 0000 0207       minimaptr = minima;
	LDI  R30,LOW(_minima)
	LDI  R31,HIGH(_minima)
	STS  _minimaptr,R30
	STS  _minimaptr+1,R31
; 0000 0208       maxtimeptr = maxtime;
	LDI  R30,LOW(_maxtime)
	LDI  R31,HIGH(_maxtime)
	STS  _maxtimeptr,R30
	STS  _maxtimeptr+1,R31
; 0000 0209       mintimeptr = mintime;
	LDI  R30,LOW(_mintime)
	LDI  R31,HIGH(_mintime)
	STS  _mintimeptr,R30
	STS  _mintimeptr+1,R31
; 0000 020A       mxpos = 0;
	LDI  R30,LOW(0)
	STS  _mxpos,R30
; 0000 020B       mnpos = 0;
	STS  _mnpos,R30
; 0000 020C       debugloopcounter = 0;
	STS  _debugloopcounter,R30
; 0000 020D       debugloopcounter2 = 0;
	STS  _debugloopcounter2,R30
; 0000 020E       dataptr = data;
	LDI  R30,LOW(_data)
	LDI  R31,HIGH(_data)
	STS  _dataptr,R30
	STS  _dataptr+1,R31
; 0000 020F 
; 0000 0210     end  // end if PINB.0
; 0000 0211 
; 0000 0212     if (PINB.3 == 0)
_0x2A:
; 0000 0213     begin
; 0000 0214 
; 0000 0215     end
; 0000 0216 
; 0000 0217 
; 0000 0218   end // end while(1)
	ADIW R28,5
	RJMP _0x21
; 0000 0219 end
_0x58:
	RJMP _0x58
;
;/*
;unsigned int minima[30]; // store indices of the transitions to minima (minima start points)
;unsigned int *minimaptr;
;unsigned int maxima[30]; // store indices of the transitions to maxima (maxima start points)
;unsigned int *maximaptr;
;*/
;// minimaptr, maximaptr point 1 beyond last valid transition size
;void spitIndices(void)
; 0000 0223 begin
; 0000 0224   unsigned int *pmin;
; 0000 0225   unsigned int *pmax;
; 0000 0226   unsigned int *pmintime;
; 0000 0227   unsigned int *pmaxtime;
; 0000 0228   pmin = minima;
;	*pmin -> R16,R17
;	*pmax -> R18,R19
;	*pmintime -> R20,R21
;	*pmaxtime -> Y+6
; 0000 0229   pmax = maxima;
; 0000 022A   pmintime = mintime;
; 0000 022B   pmaxtime = maxtime;
; 0000 022C   sprintf(t_buffer, "pmin %d\r\n", *pmin);
; 0000 022D   puts_int();
; 0000 022E   delay_ms(500);
; 0000 022F   *minimaptr = lastpoint;
; 0000 0230   sprintf(t_buffer, "minmaptr %d\r\n", *minimaptr);
; 0000 0231   puts_int();
; 0000 0232   delay_ms(500);
; 0000 0233   sprintf(t_buffer, "numpoints: %d\r\n", pointnum);
; 0000 0234   puts_int();
; 0000 0235   delay_ms(500);
; 0000 0236   sprintf(t_buffer, "debuglp: %d\r\n", debugloopcounter);
; 0000 0237   puts_int();
; 0000 0238   delay_ms(500);
; 0000 0239   sprintf(t_buffer, "debuglp2: %d\r\n", debugloopcounter2);
; 0000 023A   puts_int();
; 0000 023B   delay_ms(500);
; 0000 023C   putsf(minpoints);
; 0000 023D   while (pmin < minimaptr)
; 0000 023E   begin
; 0000 023F     //sprintf(t_buffer, "%d\r\n", *pmin);
; 0000 0240     //puts_int();
; 0000 0241     //delay_ms(1000);
; 0000 0242     itoa(*pmin, t_buffer);
; 0000 0243     //fmtEndline(t_buffer);
; 0000 0244     puts_int();
; 0000 0245     while (!t_ready) {};
; 0000 0246     pmin++;
; 0000 0247 
; 0000 0248     sprintf(t_buffer, " time: %d\r\n", *pmintime);
; 0000 0249     puts_int();
; 0000 024A     while (!t_ready) {};
; 0000 024B     pmintime++;
; 0000 024C   end
; 0000 024D   putsf(maxpoints);
; 0000 024E   while (pmax < maximaptr)
; 0000 024F   begin
; 0000 0250     itoa(*pmax, t_buffer);
; 0000 0251     //fmtEndline(t_buffer);
; 0000 0252     puts_int();
; 0000 0253     while (!t_ready) {};
; 0000 0254     pmax++;
; 0000 0255 
; 0000 0256     sprintf(t_buffer, " time: %d\r\n", *pmaxtime);
; 0000 0257     puts_int();
; 0000 0258     while (!t_ready) {};
; 0000 0259     pmaxtime++;
; 0000 025A   end
; 0000 025B end
;
;// dataptr points to one beyond last value
;void spitData(void)
; 0000 025F begin
; 0000 0260   char *loopdata;
; 0000 0261   putsf(test1);
;	*loopdata -> R16,R17
; 0000 0262   loopdata = data;
; 0000 0263   while (loopdata < dataptr)
; 0000 0264   begin
; 0000 0265     itoa(*loopdata, t_buffer); // convert array val to a string
; 0000 0266     fmtEndline(t_buffer);
; 0000 0267     puts_int();
; 0000 0268     while (!t_ready) {}; // wait for transmit to complete
; 0000 0269     loopdata++;
; 0000 026A   end
; 0000 026B   dataptr = data; // put dataptr back to beginning of array
; 0000 026C end
;
;void fmtEndline(unsigned char *array)
; 0000 026F begin
_fmtEndline:
; 0000 0270     formatindex = 0;
	ST   -Y,R27
	ST   -Y,R26
;	*array -> Y+0
	CLR  R10
; 0000 0271     while (array[formatindex] != 0) formatindex++; //edit 420
_0x71:
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ADD  R26,R10
	ADC  R27,R30
	LD   R30,X
	CPI  R30,0
	BREQ _0x73
	INC  R10
	RJMP _0x71
_0x73:
; 0000 0272 array[formatindex] = '\n';
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ADD  R26,R10
	ADC  R27,R30
	LDI  R30,LOW(10)
	ST   X,R30
; 0000 0273     array[formatindex+1] = '\r';       //edit 420
	MOV  R30,R10
	LDI  R31,0
	ADIW R30,1
	LD   R26,Y
	LDD  R27,Y+1
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(13)
	ST   X,R30
; 0000 0274     array[formatindex+2] = 0;       //edit 420
	MOV  R30,R10
	LDI  R31,0
	ADIW R30,2
	LD   R26,Y
	LDD  R27,Y+1
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
; 0000 0275 end
	JMP  _0x20C0003
;
;
;// this function should attempt to make sense of the data
;// at first it will update its variables only depending on the current input
;// it should be called once per input
;// *dataptr should point to last updated value
;void interpret(void)
; 0000 027D begin
; 0000 027E   longaverage = 0;
; 0000 027F end
;
;
;
;
;//fills in the width, widthbinary array, call after all scanning is done in main
;void getwidthbinary(void)
; 0000 0286 begin
_getwidthbinary:
; 0000 0287   unsigned int *wmin;
; 0000 0288   unsigned int *wmax;
; 0000 0289   unsigned char i;
; 0000 028A   unsigned int minreference; // min thickness
; 0000 028B   unsigned int maxreference; // max thickness value
; 0000 028C   unsigned int threshold; // average of last max and min
; 0000 028D   //float threshold;
; 0000 028E   unsigned int dynamic;
; 0000 028F   wmin = minima;
	SBIW R28,8
	CALL __SAVELOCR6
;	*wmin -> R16,R17
;	*wmax -> R18,R19
;	i -> R21
;	minreference -> Y+12
;	maxreference -> Y+10
;	threshold -> Y+8
;	dynamic -> Y+6
	__POINTWRM 16,17,_minima
; 0000 0290   wmax = maxima;
	__POINTWRM 18,19,_maxima
; 0000 0291   width[0] = *wmax;
	MOVW R26,R18
	CALL __GETW1P
	STS  _width,R30
	STS  _width+1,R31
; 0000 0292   //merge maxima and minima array into one array, ignoring the first minima pt
; 0000 0293   //(initial white space to first black stripe)
; 0000 0294   // WIDTH: contains actual width
; 0000 0295   for(i=1; i<69; i=i+2)
	LDI  R21,LOW(1)
_0x75:
	CPI  R21,69
	BRSH _0x76
; 0000 0296   begin
; 0000 0297     wmax++;
	__ADDWRN 18,19,2
; 0000 0298     wmin++;
	__ADDWRN 16,17,2
; 0000 0299     width[i] = *wmin;
	MOV  R30,R21
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R26,R16
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 029A     width[i+1] = *wmax;
	MOV  R30,R21
	LDI  R31,0
	ADIW R30,1
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R26,R18
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 029B   end
	SUBI R21,-LOW(2)
	RJMP _0x75
_0x76:
; 0000 029C   //since the first width binary for "*" is thin, we use it as a reference
; 0000 029D   minreference = width[0];
	LDS  R30,_width
	LDS  R31,_width+1
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 029E   maxreference = width[1];
	__GETW1MN _width,2
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 029F   threshold = (minreference+maxreference)>>1;
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R26
	LSR  R31
	ROR  R30
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 02A0   //threshold = (.66*(float)minreference + .33*(float)maxreference)/2; // threshold is average of last min,max
; 0000 02A1   sprintf(t_buffer, "minref: %i\r\n", minreference);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,100
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 02A2   puts_int();
	RCALL _puts_int
; 0000 02A3   while (!t_ready) {};
_0x77:
	TST  R9
	BREQ _0x77
; 0000 02A4   widthbinary[0] = 0; //first stripe is always thin (black)\
	LDI  R30,LOW(0)
	STS  _widthbinary,R30
	STS  _widthbinary+1,R30
; 0000 02A5   dynamic = 2.0;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 02A6   for (i=1; i<69; i++)
	LDI  R21,LOW(1)
_0x7B:
	CPI  R21,69
	BRLO PC+3
	JMP _0x7C
; 0000 02A7   begin
; 0000 02A8     //if the thickness is greater than twice the thin width, we got a thick one
; 0000 02A9     if (width[i] > (threshold) )
	MOV  R30,R21
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x7D
; 0000 02AA     begin
; 0000 02AB       widthbinary[i] = 1;
	MOV  R30,R21
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   X+,R30
	ST   X,R31
; 0000 02AC       maxreference = width[i];
	MOV  R30,R21
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 02AD       //threshold = (.66*(float)minreference + .33*(float)maxreference)/2; // threshold is average of last min,max
; 0000 02AE       threshold = (minreference+maxreference)>>1;
	RJMP _0xDB
; 0000 02AF     end
; 0000 02B0     else
_0x7D:
; 0000 02B1     begin
; 0000 02B2       widthbinary[i] = 0; //else we got a thin one
	MOV  R30,R21
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0000 02B3       minreference =  width[i]; // update minreference to be this thin
	MOV  R30,R21
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 02B4       //threshold = (.66*(float)minreference + .33*(float)maxreference)/2; // threshold is average of last min,max
; 0000 02B5       threshold = (minreference+maxreference)>>1;
_0xDB:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R26
	LSR  R31
	ROR  R30
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 02B6     end
; 0000 02B7 /*
; 0000 02B8   for (i=1; i<69; i++)
; 0000 02B9   begin
; 0000 02BA     //if the thickness is greater than twice the thin width, we got a thick one
; 0000 02BB     //if (width[i] > (dynamic* width[i-1])) widthbinary[i] = 1;
; 0000 02BC     if (width[i] > (dynamic*minreference)) widthbinary[i] = 1;
; 0000 02BD     else
; 0000 02BE     begin
; 0000 02BF       widthbinary[i] = 0; //else we got a thin one
; 0000 02C0       minreference =  width[i]; // update minreference to be this thin bar
; 0000 02C1     end
; 0000 02C2 */
; 0000 02C3     /* // old stuff
; 0000 02C4     //if (widthbinary[i] = 1)//if the current value is thick
; 0000 02C5     //begin
; 0000 02C6     //  dynamic = width[i]/width[i-1];
; 0000 02C7     //  minreference = width[i]/dynamic; //
; 0000 02C8     //end
; 0000 02C9     //if (widthbinary[i] = 0)//if the current value is thin
; 0000 02CA     //minreference = width[i];
; 0000 02CB     */
; 0000 02CC   end
	SUBI R21,-1
	RJMP _0x7B
_0x7C:
; 0000 02CD end
	CALL __LOADLOCR6
	ADIW R28,14
	RET
;
;void spitwidth(void)
; 0000 02D0 begin
_spitwidth:
; 0000 02D1   unsigned char i;
; 0000 02D2   putsf(widthprint);
	ST   -Y,R17
;	i -> R17
	LDI  R26,LOW(_widthprint*2)
	LDI  R27,HIGH(_widthprint*2)
	CALL _putsf
; 0000 02D3   for (i=0; i<69; i++)
	LDI  R17,LOW(0)
_0x80:
	CPI  R17,69
	BRSH _0x81
; 0000 02D4   begin
; 0000 02D5     sprintf(t_buffer, "%i: ", i);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,113
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 02D6     puts_int();
	RCALL _puts_int
; 0000 02D7     while (!t_ready) {};
_0x82:
	TST  R9
	BREQ _0x82
; 0000 02D8     itoa(width[i], t_buffer);
	MOV  R30,R17
	LDI  R26,LOW(_width)
	LDI  R27,HIGH(_width)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	CALL _itoa
; 0000 02D9     fmtEndline(t_buffer);
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	RCALL _fmtEndline
; 0000 02DA     puts_int();
	RCALL _puts_int
; 0000 02DB     while (!t_ready) {};
_0x85:
	TST  R9
	BREQ _0x85
; 0000 02DC   end
	SUBI R17,-1
	RJMP _0x80
_0x81:
; 0000 02DD   putsf(widthbiprint);
	LDI  R26,LOW(_widthbiprint*2)
	LDI  R27,HIGH(_widthbiprint*2)
	CALL _putsf
; 0000 02DE   for (i=0; i<69; i++)
	LDI  R17,LOW(0)
_0x89:
	CPI  R17,69
	BRSH _0x8A
; 0000 02DF   begin
; 0000 02E0     sprintf(t_buffer, "%i: ", i);
	LDI  R30,LOW(_t_buffer)
	LDI  R31,HIGH(_t_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,113
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 02E1     puts_int();
	RCALL _puts_int
; 0000 02E2     while (!t_ready) {};
_0x8B:
	TST  R9
	BREQ _0x8B
; 0000 02E3     itoa(widthbinary[i], t_buffer);
	MOV  R30,R17
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	CALL _itoa
; 0000 02E4     fmtEndline(t_buffer);
	LDI  R26,LOW(_t_buffer)
	LDI  R27,HIGH(_t_buffer)
	RCALL _fmtEndline
; 0000 02E5     puts_int();
	RCALL _puts_int
; 0000 02E6     while (!t_ready) {};
_0x8E:
	TST  R9
	BREQ _0x8E
; 0000 02E7   end
	SUBI R17,-1
	RJMP _0x89
_0x8A:
; 0000 02E8 end
	RJMP _0x20C0007
;
;#include "finaldecode.c"
;
;
;
;//extract the 69 character array, widthbinary, into 7 separate integers for comparison
;//widthstring[7] are rdy for comparison after this
;void widthseparate(void)
; 0000 02EA begin
_widthseparate:
;  unsigned char i;//temporary indices
;
;  // widthbinary is type unsigned int array
;  // widthstring is type unsigned int array
;
;  //clean the crap up in each integer, just in case
;  for(i=0; i<7; i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x92:
	CPI  R17,7
	BRSH _0x93
;  begin
;    widthstring[i] = 0;
	MOV  R30,R17
	LDI  R26,LOW(_widthstring)
	LDI  R27,HIGH(_widthstring)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;  end
	SUBI R17,-1
	RJMP _0x92
_0x93:
;
;  //I am sure there is a better way to do this(ie: one more outer loop)
;  //but I cant think of anything right now
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0x95:
	CPI  R17,9
	BRSH _0x96
;  begin
;    widthstring[0] = widthstring[0] | (widthbinary[8-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	LDS  R26,_widthstring
	LDS  R27,_widthstring+1
	OR   R30,R26
	OR   R31,R27
	STS  _widthstring,R30
	STS  _widthstring+1,R31
;  end
	SUBI R17,-1
	RJMP _0x95
_0x96:
;
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0x98:
	CPI  R17,9
	BRSH _0x99
;  begin
;    widthstring[1] = widthstring[1] | (widthbinary[18-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(18)
	LDI  R27,HIGH(18)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,2
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,2
;  end
	SUBI R17,-1
	RJMP _0x98
_0x99:
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0x9B:
	CPI  R17,9
	BRSH _0x9C
;  begin
;    widthstring[2] = widthstring[2] | (widthbinary[28-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(28)
	LDI  R27,HIGH(28)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,4
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,4
;  end
	SUBI R17,-1
	RJMP _0x9B
_0x9C:
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0x9E:
	CPI  R17,9
	BRSH _0x9F
;  begin
;    widthstring[3] = widthstring[3] | (widthbinary[38-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(38)
	LDI  R27,HIGH(38)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,6
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,6
;  end
	SUBI R17,-1
	RJMP _0x9E
_0x9F:
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0xA1:
	CPI  R17,9
	BRSH _0xA2
;  begin
;    widthstring[4] = widthstring[4] | (widthbinary[48-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(48)
	LDI  R27,HIGH(48)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,8
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,8
;  end
	SUBI R17,-1
	RJMP _0xA1
_0xA2:
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0xA4:
	CPI  R17,9
	BRSH _0xA5
;  begin
;    widthstring[5] = widthstring[5] | (widthbinary[58-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(58)
	LDI  R27,HIGH(58)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,10
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,10
;  end
	SUBI R17,-1
	RJMP _0xA4
_0xA5:
;
;  for(i=0; i<9; i++)
	LDI  R17,LOW(0)
_0xA7:
	CPI  R17,9
	BRSH _0xA8
;  begin
;    widthstring[6] = widthstring[6] | (widthbinary[68-i]<<i);
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(68)
	LDI  R27,HIGH(68)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(_widthbinary)
	LDI  R27,HIGH(_widthbinary)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOV  R30,R17
	CALL __LSLW12
	__GETW2MN _widthstring,12
	OR   R30,R26
	OR   R31,R27
	__PUTW1MN _widthstring,12
;  end
	SUBI R17,-1
	RJMP _0xA7
_0xA8:
;
;end
	RJMP _0x20C0007
;
;
;
;
;
;
;  /* sample barcode character extraction
;  widthstring[0] = widthstring[0] | widthbinary[0]<<0;
;  widthstring[0] = widthstring[0] | widthbinary[1]<<1;
;  widthstring[0] = widthstring[0] | widthbinary[2]<<2;
;  widthstring[0] = widthstring[0] | widthbinary[3]<<3;
;  widthstring[0] = widthstring[0] | widthbinary[4]<<4;
;  widthstring[0] = widthstring[0] | widthbinary[5]<<5;
;  widthstring[0] = widthstring[0] | widthbinary[6]<<6;
;  widthstring[0] = widthstring[0] | widthbinary[7]<<7;
;  widthstring[0] = widthstring[0] | widthbinary[8]<<8;
;
;  widthstring[1] = widthstring[1] | widthbinary[10]<<0;
;  widthstring[1] = widthstring[1] | widthbinary[11]<<1;
;  widthstring[1] = widthstring[1] | widthbinary[12]<<2;
;  widthstring[1] = widthstring[1] | widthbinary[13]<<3;
;  widthstring[1] = widthstring[1] | widthbinary[14]<<4;
;  widthstring[1] = widthstring[1] | widthbinary[15]<<5;
;  widthstring[1] = widthstring[1] | widthbinary[16]<<6;
;  widthstring[1] = widthstring[1] | widthbinary[17]<<7;
;  widthstring[1] = widthstring[1] | widthbinary[18]<<8;
;  */
;//end  //!!!! what is this end for
;
;
;//translates width code into the appropriate ascii character according to
;//standard Code 39, to be filled into totalcode array
;unsigned char width2ascii(unsigned int widthchar)
;begin
_width2ascii:
;  unsigned char charindex;
;
;  if (widthchar != 0x0000) //crap data while not active scanning, either all white or all black
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	widthchar -> Y+1
;	charindex -> R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BRNE PC+3
	JMP _0xA9
;  begin
;
;    for (charindex=0; charindex<44; charindex++) //only accepting 0 to 43
	LDI  R17,LOW(0)
_0xAB:
	CPI  R17,44
	BRSH _0xAC
;    begin
;      if (codetbl[charindex]==widthchar)  break;
	MOV  R30,R17
	LDI  R26,LOW(_codetbl*2)
	LDI  R27,HIGH(_codetbl*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW2PF
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0xAC
;    end
	SUBI R17,-1
	RJMP _0xAB
_0xAC:
;
;    if (charindex<10) charindex+= 48; //scanned character is a digit
	CPI  R17,10
	BRSH _0xAE
	SUBI R17,-LOW(48)
;    else if(charindex>9 & charindex<36) charindex+= 55; //scanner char is
	RJMP _0xAF
_0xAE:
	MOV  R26,R17
	LDI  R30,LOW(9)
	CALL __GTB12U
	MOV  R0,R30
	LDI  R30,LOW(36)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0xB0
	SUBI R17,-LOW(55)
;                                                        //an alphabet
;    else if(charindex ==36) charindex = 45; //-
	RJMP _0xB1
_0xB0:
	CPI  R17,36
	BRNE _0xB2
	LDI  R17,LOW(45)
;    else if(charindex ==37) charindex = 46; //.
	RJMP _0xB3
_0xB2:
	CPI  R17,37
	BRNE _0xB4
	LDI  R17,LOW(46)
;    else if(charindex ==38) charindex = 32; //space
	RJMP _0xB5
_0xB4:
	CPI  R17,38
	BRNE _0xB6
	LDI  R17,LOW(32)
;    else if(charindex ==39) charindex = 42; //*
	RJMP _0xB7
_0xB6:
	CPI  R17,39
	BRNE _0xB8
	LDI  R17,LOW(42)
;    else if(charindex ==40) charindex = 36; //$
	RJMP _0xB9
_0xB8:
	CPI  R17,40
	BRNE _0xBA
	LDI  R17,LOW(36)
;    else if(charindex ==41) charindex = 47; //"/"
	RJMP _0xBB
_0xBA:
	CPI  R17,41
	BRNE _0xBC
	LDI  R17,LOW(47)
;    else if(charindex ==42) charindex = 43; //+
	RJMP _0xBD
_0xBC:
	CPI  R17,42
	BRNE _0xBE
	LDI  R17,LOW(43)
;    else if(charindex ==43) charindex = 37; //%
	RJMP _0xBF
_0xBE:
	CPI  R17,43
	BRNE _0xC0
	LDI  R17,LOW(37)
;    else charindex = 0; //invalid code, outout error
	RJMP _0xC1
_0xC0:
	LDI  R17,LOW(0)
;
;  end
_0xC1:
_0xBF:
_0xBD:
_0xBB:
_0xB9:
_0xB7:
_0xB5:
_0xB3:
_0xB1:
_0xAF:
;  return charindex; //charindex is the current barcode character in ascii
_0xA9:
	MOV  R30,R17
	JMP  _0x20C0002
;end
;
;//return the error value of current character, to be filled into errorvalue array
;unsigned char width2error(unsigned int widthchar)
;begin
_width2error:
;  unsigned char charindex, errorvalue;
;
;  if (widthchar != 0x0000)
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	widthchar -> Y+2
;	charindex -> R17
;	errorvalue -> R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0xC2
;  begin
;
;    for (charindex=0; charindex<44; charindex++) //only accepting 0 to 43
	LDI  R17,LOW(0)
_0xC4:
	CPI  R17,44
	BRSH _0xC5
;    begin
;      if (codetbl[charindex]==widthchar)  break;
	MOV  R30,R17
	LDI  R26,LOW(_codetbl*2)
	LDI  R27,HIGH(_codetbl*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW2PF
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0xC5
;    end
	SUBI R17,-1
	RJMP _0xC4
_0xC5:
;
;    /*assign the error checking value for each scanned character,*/
;    //for character index 0 to 38 (0 to 9, A to Z, -, ., space)
;    //errorvalue = index
;    if(charindex>=0 & charindex<39) errorvalue = charindex;
	MOV  R26,R17
	LDI  R30,LOW(0)
	CALL __GEB12U
	MOV  R0,R30
	LDI  R30,LOW(39)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0xC7
	MOV  R16,R17
;    //for character index 39 to 44 ($, /, +,%) errorvalue = index-1
;    //since we have to skip *
;    else if(charindex>39 & charindex<44) errorvalue=  charindex-1;
	RJMP _0xC8
_0xC7:
	MOV  R26,R17
	LDI  R30,LOW(39)
	CALL __GTB12U
	MOV  R0,R30
	LDI  R30,LOW(44)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0xC9
	MOV  R30,R17
	SUBI R30,LOW(1)
	MOV  R16,R30
;    else if(charindex==39) errorvalue = 0; //doesnt matter, since element 0
	RJMP _0xCA
_0xC9:
	CPI  R17,39
	BRNE _0xCB
	LDI  R16,LOW(0)
;                                           //is not accounted for in errorcheck
;  end
_0xCB:
_0xCA:
_0xC8:
;  return errorvalue;
_0xC2:
	MOV  R30,R16
	RJMP _0x20C0006
;end
;
;//extract the actual item code, from the 2nd character to
;//the 3rd from the last character,
;//ex: * 1 2 3 4 A *
;//we only want to store 1 2 3 4, since the two * are starting and ending
;//character, and A (errorvalue 10) is the error checking character
;void getcode(void)
;begin
_getcode:
;  unsigned char i;
;  for(i=1; i<stringlength-2; i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(1)
_0xCD:
	CPI  R17,5
	BRSH _0xCE
;  begin
;    itemcode[i-1]= totalcode[i];
	MOV  R30,R17
	LDI  R31,0
	MOVW R0,R30
	SBIW R30,1
	SUBI R30,LOW(-_itemcode)
	SBCI R31,HIGH(-_itemcode)
	MOVW R26,R30
	MOVW R30,R0
	SUBI R30,LOW(-_totalcode)
	SBCI R31,HIGH(-_totalcode)
	LD   R30,Z
	ST   X,R30
;  end
	SUBI R17,-1
	RJMP _0xCD
_0xCE:
;end
_0x20C0007:
	LD   R17,Y+
	RET
;
;//check and see if the string we just scanned is correct, need to pass in
;//errorvalue array and 2nd to last scanned character of the scanned string
;//in ascii
;unsigned char errorcheck (unsigned char* errorarray)
;begin
_errorcheck:
;  unsigned char i, sum=0;
;  /*
;  errorarray[1] = 1;
;  errorarray[2] = 2;
;  errorarray[3] = 3;
;  errorarray[4] = 4;
;  errorarray[5] = 10;
;  */
;  for (i=1; i<stringlength-2;i++)
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	*errorarray -> Y+2
;	i -> R17
;	sum -> R16
	LDI  R16,0
	LDI  R17,LOW(1)
_0xD0:
	CPI  R17,5
	BRSH _0xD1
;  begin
;    sum += errorarray[i];
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ADD  R16,R30
;  end
	SUBI R17,-1
	RJMP _0xD0
_0xD1:
;  sum = sum % 43;
	MOV  R26,R16
	CLR  R27
	LDI  R30,LOW(43)
	LDI  R31,HIGH(43)
	CALL __MODW21
	MOV  R16,R30
;  //a scanned string is only correct if its character sum mod 43 == checkchat
;  if (sum == errorarray[stringlength-2]) return 1;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R30,Z+5
	CP   R30,R16
	BRNE _0xD2
	LDI  R30,LOW(1)
	RJMP _0x20C0006
;  else return 0;
_0xD2:
	LDI  R30,LOW(0)
;end
_0x20C0006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
;
;//initialize the lcd screen, call in the beginning of the main program
;void preplcd(void)
;begin
_preplcd:
;  lcd_init(LCDwidth);
	LDI  R26,LOW(16)
	CALL _lcd_init
;  lcd_clear();
	CALL _lcd_clear
;  lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  //lcd_putsf("Number=");   //another string from flash
;  lcd_putsf("CDE:"); //product barcode (0,0) to (0,3)
	__POINTW2FN _0x0,118
	CALL _lcd_putsf
;
;  lcd_gotoxy(9,0);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  lcd_putsf("PRC:"); //product price (0,9) to (0,12)
	__POINTW2FN _0x0,123
	CALL _lcd_putsf
;
;  lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
;  lcd_putsf("NAME:");//product name (1,0) to (1,4)
	__POINTW2FN _0x0,128
	RJMP _0x20C0005
;
;
;  /*
;  sprintf(temp, "CDE:");
;  lcd_puts(temp); //product barcode (0,0) to (0,3)
;  lcd_gotoxy(0,9);
;  sprintf(temp, "PRC:");
;  lcd_puts(temp); //product price (0,9) to (0,12)
;  lcd_gotoxy(1,0);
;  sprintf(temp, "NAME:");
;  lcd_puts(temp);//product name (1,0) to (1,4)
;  */
;
;
;end
;
;//wipe lcd clean except labels
;void wipelcd(void)
;begin
_wipelcd:
;  lcd_clear();
	CALL _lcd_clear
;  lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  lcd_putsf("CDE:"); //product barcode (0,0) to (0,3)
	__POINTW2FN _0x0,118
	CALL _lcd_putsf
;  lcd_gotoxy(9,0);
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  lcd_putsf("PRC:"); //product price (0,9) to (0,12)
	__POINTW2FN _0x0,123
	CALL _lcd_putsf
;  lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
;  lcd_putsf("NAME:");//product name (1,0) to (1,4)
	__POINTW2FN _0x0,128
	RJMP _0x20C0005
;end
;
;//takes in a inventory index and then outputs the product's barcode,
;//price and name onto the LCD screen
;void printproduct(unsigned char invenindex)
;begin
_printproduct:
;  unsigned char code_buffer[10], price_buffer[10], name_buffer[10];
;  unsigned char string[10];
;  unsigned char indx;
;
;  wipelcd();
	ST   -Y,R26
	SBIW R28,40
	ST   -Y,R17
;	invenindex -> Y+41
;	code_buffer -> Y+31
;	price_buffer -> Y+21
;	name_buffer -> Y+11
;	string -> Y+1
;	indx -> R17
	RCALL _wipelcd
;
;  //not sure about conversion type, code and name are in ascii, price is in decimal
;  sprintf(code_buffer, "%-i", inventory_code[invenindex]);
	MOVW R30,R28
	ADIW R30,31
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,134
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+45
	LDI  R26,LOW(_inventory_code)
	LDI  R27,HIGH(_inventory_code)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;  sprintf(name_buffer, "%-i", inventory_name[invenindex]);
	MOVW R30,R28
	ADIW R30,11
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,134
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+45
	LDI  R26,LOW(7)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_inventory_name)
	SBCI R31,HIGH(-_inventory_name)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;  sprintf(price_buffer, "%-i", inventory_price[invenindex]);
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,134
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+45
	LDI  R31,0
	SUBI R30,LOW(-_inventory_price)
	SBCI R31,HIGH(-_inventory_price)
	LD   R30,Z
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;  wipelcd();
	RCALL _wipelcd
;  for (indx = 0; indx < 4; indx++)
	LDI  R17,LOW(0)
_0xD5:
	CPI  R17,4
	BRSH _0xD6
;  begin
;    string[indx] = inventory_code[invenindex][indx];
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LDD  R30,Y+41
	LDI  R26,LOW(_inventory_code)
	LDI  R27,HIGH(_inventory_code)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
;  end
	SUBI R17,-1
	RJMP _0xD5
_0xD6:
;  string[4] = 0;
	LDI  R30,LOW(0)
	STD  Y+5,R30
;  lcd_gotoxy(4,0); // print inventory code
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  //sprintf(string, "test");
;  lcd_puts(string);
	MOVW R26,R28
	ADIW R26,1
	CALL _lcd_puts
;
;  //lcd_puts(code_buffer); //print product barcode
;  lcd_gotoxy(5,1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
;  for (indx = 0; indx < 7; indx++)
	LDI  R17,LOW(0)
_0xD8:
	CPI  R17,7
	BRSH _0xD9
;  begin
;    string[indx] = inventory_name[invenindex][indx];
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+41
	LDI  R26,LOW(7)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_inventory_name)
	SBCI R31,HIGH(-_inventory_name)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
;  end
	SUBI R17,-1
	RJMP _0xD8
_0xD9:
;  string[7] = 0;
	LDI  R30,LOW(0)
	STD  Y+8,R30
;  lcd_puts(string);
	MOVW R26,R28
	ADIW R26,1
	CALL _lcd_puts
;
;  lcd_gotoxy(13,0);
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;  lcd_puts(price_buffer);//print product price
	MOVW R26,R28
	ADIW R26,21
	CALL _lcd_puts
;  //lcd_puts(price_buffer);
;  //lcd_puts(inventory_name[invenindex]);//print product name
;
;end
	LDD  R17,Y+0
	ADIW R28,42
	RET
;
;void printready(void)
;begin
_printready:
;  wipelcd();
	RCALL _wipelcd
;  lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
;  lcd_putsf("READY");
	__POINTW2FN _0x0,138
	RJMP _0x20C0005
;end
;
;// pass an array of length 4 to this function that contains the ascii code
;void printascii(unsigned char *ascii)
;begin
;  ascii[4] = 0;
;	*ascii -> Y+0
;  lcd_gotoxy(4,0);
;  lcd_puts(ascii);
;end
;
;/*
;outputs error when:
;1. Scanned character does not match any code 39 ascii codes
;2. Scanned codes does not match any pre-defined inventory barcodes
;*/
;void printerror(void)
;begin
_printerror:
;  lcd_gotoxy(13,1);
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
;  lcd_putsf("ERR"); //print ERR
	__POINTW2FN _0x0,144
_0x20C0005:
	CALL _lcd_putsf
;end
	RET
;
;
;
;/*
;
;    // the below if statement could be done with a TX complete interrupt
;    if (t_ready) // if we are done sending the last ADC conversion
;    begin
;      formatindex = 0; //reset formatindex for each conversion edit 420
;      readADC = ADCH;
;      ADCSR.6 = 1; // start new conversion
;      itoa(readADC, t_buffer); // convert ADCH to a string
;      while (t_buffer[formatindex] != 0) formatindex++;   //edit 420
;      t_buffer[formatindex] = "\n";                       //edit 420
;      t_buffer[formatindex+1] = "\r";                     //edit 420
;      t_buffer[formatindex+2] = "\0";                     //edit 420
;      // print a newline
;      puts_int(); // print ADC value
;      //t_buffer = "\r\n";
;//      t_buffer[0] = '\r';
;//      t_buffer[1] = '\n';
;//      t_buffer[2] = 0;
;//      puts_int(); // print newline
;       //putsf(newline); edit 420, see UART ISR
;    //delay_ms(1000);
;    end  // end if t_ready
;    */
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
	ST   -Y,R26
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
	JMP  _0x20C0001
_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000003:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000005
	MOV  R26,R17
	RCALL _putchar
	RJMP _0x2000003
_0x2000005:
	LDI  R26,LOW(10)
	RCALL _putchar
	JMP  _0x20C0002
_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000006:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000008
	MOV  R26,R17
	RCALL _putchar
	RJMP _0x2000006
_0x2000008:
	LDI  R26,LOW(10)
	RCALL _putchar
	JMP  _0x20C0002
_put_buff_G100:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0004
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_itoa:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG

	.CSEG
_strlen:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G104:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G104
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G104
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G104
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G104
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G104:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G104
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G104
	RET
__lcd_write_data:
	ST   -Y,R26
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G104
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G104
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x20C0001
__lcd_read_nibble_G104:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G104
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G104
    andi  r30,0xf0
	RET
_lcd_read_byte0_G104:
	CALL __lcd_delay_G104
	RCALL __lcd_read_nibble_G104
    mov   r26,r30
	RCALL __lcd_read_nibble_G104
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	ST   -Y,R26
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G104)
	SBCI R31,HIGH(-__base_y_G104)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x20C0003:
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R26,LOW(2)
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R26,LOW(12)
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R26,LOW(1)
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	ST   -Y,R26
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2080004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2080004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
	LD   R26,Y
	CALL __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	JMP  _0x20C0001
_lcd_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2080005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2080007
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2080005
_0x2080007:
	RJMP _0x20C0002
_lcd_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2080008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x208000A
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2080008
_0x208000A:
_0x20C0002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G104:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G104:
	ST   -Y,R26
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G104
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20C0001
_lcd_init:
	ST   -Y,R26
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G104,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G104,3
	RCALL __long_delay_G104
	LDI  R26,LOW(48)
	RCALL __lcd_init_write_G104
	RCALL __long_delay_G104
	LDI  R26,LOW(48)
	RCALL __lcd_init_write_G104
	RCALL __long_delay_G104
	LDI  R26,LOW(48)
	RCALL __lcd_init_write_G104
	RCALL __long_delay_G104
	LDI  R26,LOW(32)
	RCALL __lcd_init_write_G104
	RCALL __long_delay_G104
	LDI  R26,LOW(40)
	CALL __lcd_write_data
	RCALL __long_delay_G104
	LDI  R26,LOW(4)
	CALL __lcd_write_data
	RCALL __long_delay_G104
	LDI  R26,LOW(133)
	CALL __lcd_write_data
	RCALL __long_delay_G104
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G104
	CPI  R30,LOW(0x5)
	BREQ _0x208000B
	LDI  R30,LOW(0)
	RJMP _0x20C0001
_0x208000B:
	CALL __lcd_ready
	LDI  R26,LOW(6)
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x20C0001:
	ADIW R28,1
	RET

	.CSEG

	.DSEG
_widthstring:
	.BYTE 0xE
_errorvalue:
	.BYTE 0x7
_totalcode:
	.BYTE 0x7
_itemcode:
	.BYTE 0x4
_inventory_code:
	.BYTE 0x28
_inventory_price:
	.BYTE 0xA
_inventory_name:
	.BYTE 0x46
_t_buffer:
	.BYTE 0x14
_data:
	.BYTE 0x2BC
_blockwidth:
	.BYTE 0x64
_currentwidth:
	.BYTE 0x1
_datalast:
	.BYTE 0x2
_dataptr:
	.BYTE 0x2
_takedata:
	.BYTE 0x1
_newdata:
	.BYTE 0x1
_mn:
	.BYTE 0x2
_mnpos:
	.BYTE 0x1
_mx:
	.BYTE 0x2
_mxpos:
	.BYTE 0x1
_lookformax:
	.BYTE 0x1
_minima:
	.BYTE 0x50
_mintime:
	.BYTE 0x50
_mintimeptr:
	.BYTE 0x2
_minimalastptr:
	.BYTE 0x2
_minimaptr:
	.BYTE 0x2
_maxima:
	.BYTE 0x50
_maxtime:
	.BYTE 0x50
_maxtimeptr:
	.BYTE 0x2
_maximalastptr:
	.BYTE 0x2
_maximaptr:
	.BYTE 0x2
_currentval:
	.BYTE 0x2
_pointnum:
	.BYTE 0x2
_lastpoint:
	.BYTE 0x2
_debugloopcounter:
	.BYTE 0x1
_debugloopcounter2:
	.BYTE 0x1
_longaverage:
	.BYTE 0x1
_shortaverage:
	.BYTE 0x1
_lookfor:
	.BYTE 0x1
_width:
	.BYTE 0x8A
_widthbinary:
	.BYTE 0x8A
__seed_G101:
	.BYTE 0x4
__base_y_G104:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG

	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__GEB12U:
	CP   R26,R30
	LDI  R30,1
	BRSH __GEB12U1
	CLR  R30
__GEB12U1:
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETW2PF:
	LPM  R26,Z+
	LPM  R27,Z
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
